int? compare(a, b) {
  final result = _compare(a, b);
  return (result != 0) ? result : null;
}

int _compare(a, b) {
  if(a == b) {
    return 0;
  }
  if(a != null && b != null) {
    if(a.runtimeType == b.runtimeType) {
      if(a is Comparable) return a.compareTo(b);
      return '$a'.compareTo('$b');
    }
    return 0;
  }
  return (a != null) ? 1 : -1;
}
